<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>G-CTMQC: coefficients_evolution Module Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">G-CTMQC
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('namespacecoefficients__evolution.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#func-members">Functions/Subroutines</a>  </div>
  <div class="headertitle">
<div class="title">coefficients_evolution Module Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Evolution of the electronic coefficients.  
<a href="namespacecoefficients__evolution.html#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions/Subroutines</h2></td></tr>
<tr class="memitem:a2da8d322abba76ff6287134ddfb7e5cb"><td class="memItemLeft" align="right" valign="top">subroutine&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacecoefficients__evolution.html#a2da8d322abba76ff6287134ddfb7e5cb">rk4_coeff</a> (v, coeff, k_li, trajlabel)</td></tr>
<tr class="memdesc:a2da8d322abba76ff6287134ddfb7e5cb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Numerical integration of the non-linear differential equation describing the electronic evolution of the coefficients.  <a href="namespacecoefficients__evolution.html#a2da8d322abba76ff6287134ddfb7e5cb">More...</a><br /></td></tr>
<tr class="separator:a2da8d322abba76ff6287134ddfb7e5cb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2a7fdf5fc5474f67250bb3e0a5736bda"><td class="memItemLeft" align="right" valign="top">complex(kind=qp) function&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacecoefficients__evolution.html#a2a7fdf5fc5474f67250bb3e0a5736bda">cdot</a> (state, kfunction, v, coeff, k_li, trajlabel)</td></tr>
<tr class="memdesc:a2a7fdf5fc5474f67250bb3e0a5736bda"><td class="mdescLeft">&#160;</td><td class="mdescRight">Total time derivative of the electronic coefficients as given in the Ehrenfest algorithm, surface hopping algorithm, and CT-MQC.  <a href="namespacecoefficients__evolution.html#a2a7fdf5fc5474f67250bb3e0a5736bda">More...</a><br /></td></tr>
<tr class="separator:a2a7fdf5fc5474f67250bb3e0a5736bda"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Evolution of the electronic coefficients. </p>
<dl class="section author"><dt>Author</dt><dd>Federica Agostini, Institut de Chimie Physique, University Paris-Saclay. </dd></dl>
</div><h2 class="groupheader">Function/Subroutine Documentation</h2>
<a id="a2a7fdf5fc5474f67250bb3e0a5736bda"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2a7fdf5fc5474f67250bb3e0a5736bda">&#9670;&nbsp;</a></span>cdot()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">complex(kind=qp) function coefficients_evolution::cdot </td>
          <td>(</td>
          <td class="paramtype">integer, intent(in)&#160;</td>
          <td class="paramname"><em>state</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">complex(kind=qp), intent(in)&#160;</td>
          <td class="paramname"><em>kfunction</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">real(kind=dp), dimension(n_dof), intent(in)&#160;</td>
          <td class="paramname"><em>v</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">complex(kind=qp), dimension(nstates), intent(in)&#160;</td>
          <td class="paramname"><em>coeff</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">real(kind=dp), dimension(nstates,nstates), intent(in)&#160;</td>
          <td class="paramname"><em>k_li</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">integer, intent(in)&#160;</td>
          <td class="paramname"><em>trajlabel</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Total time derivative of the electronic coefficients as given in the Ehrenfest algorithm, surface hopping algorithm, and CT-MQC. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">state</td><td>electronic state for which the time derivative of the coefficients is computer </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">trajlabel</td><td>label of the trajectory along which the equation is integrated </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">v</td><td>velocity of trajectory along which the time derivative of the coefficient is calculated </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">k_li</td><td>term accounting for decoherence effects in CT-MQC </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">coeff</td><td>electronic coefficientes </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">kfunction</td><td>function appearing in the expression of the time increment </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">cdot</td><td>time derivative of the coefficient </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">nonadiabatic_sum</td><td>off-diagonal contribution to the time derivative of the coefficients </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">my_coeff</td><td>local temporary values of the coefficients </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">i</td><td>integer index </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">my_gap</td><td>energy-gap threshold between the spin-diabatic states to tune the effect of the spin-orbit coupling </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The values of the time derivative of the electronic coefficientes is returned. </dd></dl>

<p class="definition">Definition at line <a class="el" href="coefficients__evolution_8f90_source.html#l00116">116</a> of file <a class="el" href="coefficients__evolution_8f90_source.html">coefficients_evolution.f90</a>.</p>

</div>
</div>
<a id="a2da8d322abba76ff6287134ddfb7e5cb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2da8d322abba76ff6287134ddfb7e5cb">&#9670;&nbsp;</a></span>rk4_coeff()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">subroutine coefficients_evolution::rk4_coeff </td>
          <td>(</td>
          <td class="paramtype">real(kind=dp), dimension(n_dof), intent(in)&#160;</td>
          <td class="paramname"><em>v</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">complex(kind=qp), dimension(nstates), intent(inout)&#160;</td>
          <td class="paramname"><em>coeff</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">real(kind=dp), dimension(nstates,nstates), intent(in)&#160;</td>
          <td class="paramname"><em>k_li</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">integer, intent(in)&#160;</td>
          <td class="paramname"><em>trajlabel</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Numerical integration of the non-linear differential equation describing the electronic evolution of the coefficients. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">trajlabel</td><td>label of the trajectory along which the equation is integrated </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">v</td><td>velocity of trajectory along which the equation is integrated </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">k_li</td><td>term accounting for decoherence effects in CT-MQC </td></tr>
    <tr><td class="paramdir">[in,out]</td><td class="paramname">coeff</td><td>electronic coefficientes </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">i</td><td>integer index </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">k1,k2,k3,k4</td><td>functions appearing in the expression of the time increment </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">kfunction</td><td>function appearing in the expression of the time increment </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">my_coeff</td><td>local temporary values of the coefficients </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">normalization</td><td>norm of the electronic wavefunction after a time step </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The values of the electronic coefficientes are returned after one step of dynamics. </dd></dl>

<p class="definition">Definition at line <a class="el" href="coefficients__evolution_8f90_source.html#l00048">48</a> of file <a class="el" href="coefficients__evolution_8f90_source.html">coefficients_evolution.f90</a>.</p>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespacecoefficients__evolution.html">coefficients_evolution</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1 </li>
  </ul>
</div>
</body>
</html>
